//
//  NetworkRequest.cpp
//
//  Created by duzixi.com on 15/8/25.
//

#include "NetworkRequest.h"

using namespace std;
using boost::asio::ip::tcp;

/// POST
string PostRequest(char* host, char* path, string form) {
	long length = form.length();

	// Asio: io_serviceȻ
	boost::asio::io_service io_service;

	// ȡնб
	tcp::resolver resolver(io_service);
	tcp::resolver::query query(host, "http");
	tcp::resolver::iterator iter = resolver.resolve(query);

	// ÿһնˣֱɹsocket
	tcp::socket socket(io_service);
	boost::asio::connect(socket, iter);

	// ͷ
	// ָ "Connection: close" ڻȡӦϿӣȷļȫݡ
	boost::asio::streambuf request;
	ostream request_stream(&request);
	request_stream << "POST " << path << " HTTP/1.1\r\n";
	request_stream << "Host: " << host << "\r\n";
	request_stream << "Accept: */*\r\n";
	request_stream << "Content-Type:application/x-www-form-urlencoded\r\n";
	request_stream << "Content-Length: " << length << "\r\n";
	request_stream << "Connection: close\r\n\r\n"; // ע
	request_stream << form; //POST ͵ݱڿ

							// 
	boost::asio::write(socket, request);

	// ȡӦ״̬. Ӧ𻺳 streambuf Զ
	// ڹ컺ʱֵͨ
	boost::asio::streambuf response;
	boost::asio::read_until(socket, response, "\r\n");

	// ӦǷOK.
	istream response_stream(&response);// Ӧ
	string http_version;
	response_stream >> http_version;
	unsigned int status_code;
	response_stream >> status_code;
	string status_message;
	getline(response_stream, status_message);
	if (!response_stream || http_version.substr(0, 5) != "HTTP/") {
		printf("ЧӦ\n");
	}
	if (status_code != 200) {
		printf("Ӧ status code %d\n", status_code);
	}

	// ȡӦͷкֹͣ
	boost::asio::read_until(socket, response, "\r\n\r\n");

	// ʾӦͷ
	string header;
	int len = 0;
	while (getline(response_stream, header) && header != "\r") {
		if (header.find("Content-Length: ") == 0) {
			stringstream stream;
			stream << header.substr(16);
			stream >> len;
		}
	}

	long size = response.size();

	if (size > 0) {
		// .... do nothing
	}

	// ѭȡֱļ
	boost::system::error_code error;
	while (boost::asio::read(socket, response, boost::asio::transfer_at_least(1), error)) {
		// ȡӦ𳤶
		size = response.size();
		if (len != 0) {
			cout << size << "  Byte  " << (size * 100) / len << "%\n";
		}

	}
	if (error != boost::asio::error::eof) {
		throw boost::system::system_error(error);
	}

	cout << size << " Byte ." << endl;

	// streambufתΪstringͷ
	istream is(&response);
	is.unsetf(ios_base::skipws);
	string sz;
	sz.append(istream_iterator<char>(is), istream_iterator<char>());

	// תַ
	return sz;
}

/// GET
string GetRequest(char* host, char* path) {
	// Asio: io_serviceȻ
	boost::asio::io_service io_service;

	// ȡնб
	tcp::resolver resolver(io_service);
	tcp::resolver::query query(host, "http");
	tcp::resolver::iterator iter = resolver.resolve(query);

	// ÿһնˣֱɹsocket
	tcp::socket socket(io_service);
	boost::asio::connect(socket, iter);

	// ͷ.
	// ָ "Connection: close" ڻȡӦϿӣȷļȫݡ
	boost::asio::streambuf request;
	ostream request_stream(&request);
	request_stream << "GET " << path << " HTTP/1.1\r\n";
	request_stream << "Host: " << host << "\r\n";
	request_stream << "Accept: */*\r\n";
	request_stream << "Connection: close\r\n\r\n";

	// 
	boost::asio::write(socket, request);

	// ȡӦ״̬. Ӧ𻺳 streambuf Զ
	// ڹ컺ʱֵͨ
	boost::asio::streambuf response;
	boost::asio::read_until(socket, response, "\r\n");

	// ӦǷOK.
	istream response_stream(&response);
	string http_version;
	response_stream >> http_version;
	unsigned int status_code;
	response_stream >> status_code;
	string status_message;
	getline(response_stream, status_message);
	if (!response_stream || http_version.substr(0, 5) != "HTTP/") {
		printf("ӦЧ\n");
	}
	if (status_code != 200) {
		printf("Ӧ status code %d\n", status_code);
	}

	// ȡӦͷкֹͣ
	boost::asio::read_until(socket, response, "\r\n\r\n");

	// ʾӦͷ

	string header;
	int len = 0;
	while (getline(response_stream, header) && header != "\r") {
		if (header.find("Content-Length: ") == 0) {
			stringstream stream;
			stream << header.substr(16);
			stream >> len;
		}
	}

	long size = response.size();

	if (size > 0) {
		// ... do nothing ...
	}

	boost::system::error_code error;  // ȡ

									  // ѭȡֱļ
	while (boost::asio::read(socket, response, boost::asio::transfer_at_least(1), error)) {
		// ȡӦ𳤶
		size = response.size();
		if (len != 0) {
			cout << size << "  Byte  " << (size * 100) / len << "%" << endl;
		}
	}

	// ûжļβ׳쳣
	if (error != boost::asio::error::eof) {
		throw boost::system::system_error(error);
	}

	cout << size << " Byte ." << endl;

	// streambufתΪstringͣ
	istream is(&response);
	is.unsetf(ios_base::skipws);
	string sz;
	sz.append(istream_iterator<char>(is), istream_iterator<char>());

	return sz;
}

/// GET()
string GetRequest(string url) {
	size_t index;

	// ȥurlеЭͷ
	if (url.find("http://") != string::npos) {
		url = url.substr(7);
	}
	printf("url:%s\n", url.c_str());

	// ȡhostַ
	index = url.find("/");
	char* host = new char[index];
	strcpy(host, url.substr(0, index).c_str());

	// ȡurlPathַ
	char* urlPath = new char[url.length() - index + 1];
	strcpy(urlPath, url.substr(index, url.length() - index).c_str());

	return GetRequest(host, urlPath);
}